
linspect

local resp
resp=$(valid_url ${args[repo]})
if [[ $resp == -1 ]]; then
  echo "${args[repo]} is not a valid repo"
  exit 1
fi

local regex="${deps[perl]} -n -l -e"

local git="${deps[git]}"

local base_path=$REPOTOOL_PATH


local ssh_user;
# the ssh user to clone with

local http_user;
local http_pass;

local domain
local path
#now extract the args we need
# this is where we use perl
if [[ $resp == 1 ]]; then
  # TODO: properly extract user and password, if exists.
  output=($(echo ${args[repo]} | ${regex} '/^https?:\/\/(?:.*?:)?(.*\..*?)\/(.*?)(\.git)?$/ && print "$1 $2" ' -))
  domain=${output[0]}
  path=${output[1]}
fi

if [[ $resp == 2 ]]; then
  # TODO: properly extract ssh user, if exists.
  output=($(echo ${args[repo]} | ${regex} '/^(?:.*?@)?(.*\..*?)(?::|\/)(.*?)(\.git)?$/ && print "$1 $2" ' -))
  domain=${output[0]}
  path=${output[1]}
fi

if [[ ! -z "${args[--ssh-user]}" && -z "$ssh_user" ]]; then
  ssh_user=${args[--ssh-user]}
fi

if [[ ! -z "${args[--http-user]}" && -z "$http_user" ]]; then
  http_user=${args[--http-user]}
fi

if [[ ! -z "${args[--http-pass]}" && -z "$http_pass" ]]; then
  http_pass=${args[--http-pass]}
fi


if [[ -z "$method" ]]; then
  method=${args[--method]}
fi

lcat << EOF
found valid repo target

domain: $domain
path:   $path

ssh_user: $ssh_user
method: $method

http_user: $http_user
http_pass: $http_pass
EOF


local target_dir="$base_path/$domain/$path"

if [[ ! -d $target_dir ]]; then
  mkdir -p $target_dir
fi

cd $target_dir

local repo_url=""

case $method in
  ssh)
    repo_url="$ssh_user@$domain:$path"
    ;;
  https | http)
    # TODO: support http_user and http_pass
    repo_url="$method://$domain/$path.git"
    ;;
  *)
    echo "unrecognized clone method $method"
    exit 1
esac



# we check if we have cloned the repo via the if the .git folder exists
if [[ ! -d .git ]]; then
  # check if the remote actually exists
  $git ls-remote $repo_url > /dev/null && RC=$? || RC=$?
  if [[ $RC == 0 ]]; then
    $git clone $repo_url $target_dir >&2
  else
    echo "Could not find repo: $repo_url"
    exit 1
  fi
fi

echo dir=$target_dir domain=$domain path=$path repo_url=$repo_url

exit 0
